#! /usr/bin/perl
#############################################################################
# 
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################


$signature="<font size=-1><i>ICS</i></font>";
%month=(begin,"00",January,"01",February,"02",March,"03",April,"04",May,"05",June,"06",July,"07",August,"08",September,"09",October,"10",November,"11",December,"12",end,"13");
#
# fields ------------------------------------------------
#  call accounts
#


$ACCPINNUM=0;
$CALLDATE=1;
$CALLTIME=2;
$FROMNUM=3;
$TERMNUM=4;
$BILLTIME=5;
$BILLAMT=6;

$INTERNATIONAL=7;

$ACCOUNTBILLNUM=0;
$ACCOUNTPINNUM=1;


$ehc=0;
$total=0;  
$minutes=0;
$numberofcalls=0;
$dirname_pcc = "../../../database/pcc/";
$dirname_cc = "../../../database/cc/";

$accountFile="../../../database/.switch2.db";

sub initializeCalculations {
    $charges=0;
    $ehc=0;
    $total=0;  
    $minutes=0;
    $numberofcalls=0;
}
sub 	saveCalculations{
    $SAVEcharges=$charges;
    $SAVEehc=$ehc;
    $SAVEtotal=$total;  
    $SAVEminutes=$minutes;
    $SAVEnumberofcalls=$numberofcalls;

}

sub addPreviousCalculations {
    $charges+=$SAVEcharges;
    $ehc+=$SAVEehc;
    $total+=$SAVEtotal;
    $minutes+=$SAVEminutes;
    $numberofcalls+=$SAVEnumberofcalls;

}


#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
&PrintHeader;
&ReadEntry;
&openHtml; 
&EXECUTE;
#print "<font color=red>.<br>.<br>.<br>.<br>.<br><b> Will be available soon, please wait!<b>.<br>.<br>.<br><br></font>";

&closeHtml;
#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form

   $accNo = ($in{'accountNo'}) ? $in{'accountNo'} : -1;
   $pinNo = ($in{'pinNo'}) ? $in{'pinNo'} : -1;	

   $pcc = ($in{'PCC'}) ? $in{'PCC'} : -1;	
   $cc = ($in{'CC'}) ? $in{'CC'} : -1;	
   
   $fromDay  = ($in{'fromDay'}) ? $in{'fromDay'} : 'begin';
   $fromMonth  = ($in{'fromMonth'}) ? $in{'fromMonth'} : 'begin';
   $fromYear = ($in{'fromYear'}) ? $in{'fromYear'} : '1900';
   $toDay = ($in{'toDay'}) ? $in{'toDay'} : 'end';
   $toMonth = ($in{'toMonth'}) ? $in{'toMonth'} : 'end';
   $toYear = ($in{'toYear'}) ? $in{'toYear'} : '2100';
   $fromHour = ($in{'fromTime'}) ? $in{'fromTime'} : 0 ;
   $fromAMPM = ($in{'fromAMPM'}) ? $in{'fromAMPM'} : "AM";
   $toHour = ($in{'toTime'}) ? $in{'toTime'} : 13;
   $toAMPM = ($in{'toAMPM'}) ? $in{'toAMPM'} : "PM";
   $origin = ($in{'originNumber'}) ? $in{'originNumber'} : -1;
   $number = ($in{'calledNumber'}) ? $in{'calledNumber'} : -1;	


   $checkedFrom = ($in{'from'}) ? 1 : 0 ;
   $checkedTo =($in{'to'}) ? 1 : 0 ;  
   $checkedBetween=($in{'between'}) ? 1 : 0 ;  
   $checkedOrigin=($in{'checkOriginNumber'}) ? 1 : 0 ;
   $checkedNumber=($in{'checkCalledNumber'}) ? 1 : 0 ;
   $checkedInternational = ($in{'international'}) ? 1:0;
   $checkedInterstate = ($in{'interstate'}) ? 1 : 0;

   $fromDate=$fromYear.$month{$fromMonth} .$fromDay;
   $toDate=$toYear.$month{$toMonth} .$toDay;
   $fromTime=&convertTime2Number($fromHour,$fromAMPM);
   $toTime=&convertTime2Number($toHour,$toAMPM);

   $accpinNo=$accNo.$pinNo;
   return 0;
}

sub convertTime2Number {
     local ($hour,$ampm)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {;}
        else {$hour+=12};
     } else { if ($hour==12) {$hour=0;}}
     $n=$hour."0000";
     return $n;
}
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

#############################################################################
#  
#
#############################################################################

#############################################################################
#  verifiedAccount
#
#############################################################################

#############################################################################
#  verifiedAccount
#
#############################################################################
sub verifiedAccount {
 
        open(ACC, $accountFile);
	
        while (<ACC>) {
           ($ID,$PW,@rest)=split ( /\|/,$_); 
            if ( ($PW eq $pinNo)) {
               close(ACC); 
               return 1;
            }
        }
        close(ACC);
        return 0;
 
}
sub invalidAccountException {
&openHtml;
 
print "<br>.<br>. - $ID - $PW - $accNo - $pinNo - <br>.<br><b>Sorry, access denied!
.</b> <br>.<br>.<br>.<br>\n";
&closeHtml;
}
### ##########################################################################
#  
# invalidAccountException
#############################################################################
sub EXECUTE {
        unless (&verifiedAccount ) { &invalidAccountException; return 0;}

	if ( $checkedFrom  && $checkedTo) {
  print "<h3>Between the dates $fromMonth $fromDay $fromYear and $toMonth $toDay $toYear ..</h3>";
} elsif ( $checkedFrom ){print " <h3>Starting from the date $fromMonth $fromDay $fromYear : </h3>"; }
elsif ( $checkedTo ){print " <h3>Until the date $toMonth $toDay $toYear : </h3>";   }
else { print " <h3>All the calls</h3>";}
        &openTable;
        print "<tr><td bgcolor=beige> <font color=red><b>
CARD TYPE </td><td bgcolor=beige><font color=blue><b>
COUNTRY/ST</td><td bgcolor=beige><font color=blue><b>
COUNTRY/ST CODE</td><td bgcolor=beige><font color=blue><b>   
NUMBER OF CALLS</td><td bgcolor=beige><font color=blue><b>
MINUTES</td><td bgcolor=beige><font color=blue><b>
COST</td>
</tr>";

	if ($pcc eq "YES") {
	    $cardType="PCC";
	    &initializeCalculations;
	    opendir(CALLS, $dirname_pcc) || die "no dir .";
	    while ($fn=readdir(CALLS)) {  print ":";
		if ($fn =~ /^pcc_calls/) {&scanFile($dirname_pcc,$fn);}
	    }
	    closedir(CALLS);
	    &printTotals;
	    &saveCalculations;
	}
	if ($cc eq "YES") { 
	    &initializeCalculations;
	    $cardType="CC";
	    $charges=0;
	    opendir(CALLS, $dirname_cc) || die "no dir .";
	    while ($fn=readdir(CALLS)) { print ".";
		if ($fn =~ /^cc_calls/) {&scanFile($dirname_cc,$fn);}
	    }
	    closedir(CALLS);
	    &printTotals;
	}
	if (($cc eq "YES")&&($pcc eq "YES")) {  
	    $cardType="ALL";
	    &addPreviousCalculations;
	    &printTotals;
	}
        &closeTable;
        $total=~ s/(\d*)\.(\d)(\d)(\d*)/$1.$2$3/;

        print "<table bgcolor=yellow><tr><td><b> $total is total for these calls.</b></td></tr></table>";

    }
#
##############################################################################
#  scanFile: process each file in the directory
#
##############################################################################
sub scanFile {
    local($dirname,$fn)=@_;

    ($h1,$h2,$date,$e)=split ( /_/,$fn);
    ($y,$m,$d1,$d2)=split ( /-/,$date);
    if ($y =~ /^9/ ) {$y="19".$y;}else{$y="20".$y;}
    if ($d2 eq "") {$d2=$d1;}
    if ($d2 <$d1) {$td=$d1; $d1=$d2;$d2=$td;}
    if ( $checkedFrom  &&
	($fromYear > $y || $month{$fromMonth} >$m || ( $d2 ne "" &&  $fromDay > $d2))) {
	return 0;
    }
    if ( $checkedTo  &&
	($y > $toYear||$m > $month{$toMonth} ||( $d1 ne "" &&$d1 > $toDay))) {
	return 0;
    }

    print "<font color=red><b>.</b></font>";
    $realfile=$dirname.$fn;
    open(IN, "<$realfile"); 
    while (<IN>) {
	(@fields)=split ( /\|/,$_);
	    
	    $fields[$BILLAMT]/=100;
	    #$charges+=$fields[$BILLAMT];
	    &processCall(@fields);
    }
    close(IN);
}


#
##############################################################################
#
# process a call item 
#
##############################################################################
sub processCall {
    local (@fields)=@_;

# &printVariables;
    if (   ( ($checkedFrom 
	      && (    $fromDate <= $fields[$CALLDATE] ) 
	      ) || !$checkedFrom
	    )
       	&&( 
	   ($checkedTo 
	    && ($toDate >=  $fields[$CALLDATE] )
	    ) || !$checkedTo
	   )
	&&( 
	   ($checkedBetween
            && (
                    ($fromTime <$toTime
                     && ( $fields[$CALLTIME] >= $fromTime)
                     && ( $fields[$CALLTIME] <= $toTime)
                     )
                     ||
                    ($fromTime >=$toTime
                     && (( $fields[$CALLTIME] >= $fromTime)
                        || ( $fields[$CALLTIME] <= $toTime))
                     )
                )
            ) || !$checkedBetween
           )
        && (
	    ($checkedOrigin
	     && (($origin==$fields[$FROMNUM]))
	     ) || !$checkedOrigin
	    )
        && (
	    ($checkedNumber
	     && (($fields[$TERMNUM]=~ /^$number/ )) 
	     ) || !$checkedNumber
	    )
	&& (	
	    (($fields[$INTERNATIONAL] eq "Y") && $checkedInternational )
	    ||
	    (($fields[$INTERNATIONAL] eq "N") && $checkedInterstate )
	    )
	#-------
	)
    {
	#&printCall;
	if (  ($fields[$BILLAMT] != 0)) { 
	    $total+=$fields[$BILLAMT];
	    $numberofcalls++;
	    $minutes+=$fields[$BILLTIME];
	}
	 
        $ehc++;
    } # if ends
    

}

#
##############################################################################
#
# Results
#
##############################################################################
sub printTotals {

$_sec=$minutes%60;
$_min=$minutes/60;
$_min=sprintf("%20.0f",$_min);
if ($_sec > 0 ) {  $_min++; }

$_min = $_min." <font size=-2 color=red>min</font>";               

$tn=$number;
if ($tn =~ /^1/) { 
    $tn="<b><font color=green>1</font><font color=red>".substr($tn,1,length($tn)-8)."</font>".substr($tn,length($tn)-7,7)."</b>";
} elsif ($tn =~ /^011/)  {
    $tn="<b><font color=green>011</font><font color=red>".substr($tn,3,length($tn)-10)."</font>".substr($tn,length($tn)-7,7)."</b>";
}
$number=$tn;


    print "<tr>
<td>$cardType</td>
<td>
$COUNTRY</td><td>
$number</td><td>  
$numberofcalls (800's $ehc)</td><td>
$_min</td><td>
$total</td><td>



</tr>";
}
#
##############################################################################
#
# Results
#
##############################################################################
sub printCall {
$fields[$CALLDATE]=substr($fields[$CALLDATE],4,2)."/".substr($fields[$CALLDATE],6,2)."/". substr($fields[$CALLDATE],0,4);
# $fields[$BILLTIME].=" sec";  #substr($fields[$BILLTIME],0,2).":".substr($fields[$BILLTIME],2,2);
$_sec=$fields[$BILLTIME]%60;
$_min=($fields[$BILLTIME]-$_sec)/60;
if ($_sec > 0 ) {  $_min++; }
$fields[$BILLTIME]=$_min." <font size=-2 color=red>min</font>";                 
        #":".$_sec;
$fields[$CALLTIME]=substr($fields[$CALLTIME],0,2).":".substr($fields[$CALLTIME],2,2);
$tn=$fields[$TERMNUM];
if ($tn =~ /^1/) { 
    $tn="<b><font color=green>1</font><font color=red>".substr($tn,1,length($tn)-8)."</font>".substr($tn,length($tn)-7,7)."</b>";
} elsif ($tn =~ /^011/)  {
    $tn="<b><font color=green>011</font><font color=red>".substr($tn,3,length($tn)-10)."</font>".substr($tn,length($tn)-7,7)."</b>";
}
$fields[$TERMNUM]=$tn;
 
 
    print "<tr>
<td>
$fields[$CALLDATE]</td><td>
$fields[$CALLTIME]</td><td>  
$fields[$FROMNUM]</td><td>
$fields[$TERMNUM]</td><td>
$fields[$BILLAMT]</td><td>
$fields[$BILLTIME]</td><td>
$fields[$INTERNATIONAL]</td>
 
 
</tr>";
}


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}
sub printFooter {
  print "$signature </body></html>\n";
}

sub openTable {
print "
<TABLE ALIGN=ABSCENTER BORDER=5 CELLSPACING=6 CELLPADDING=6 BGCOLOR=gold >
";
}
sub closeTable {
print "</table>";
}
sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title>Query Results </title>
</HEAD>
<body BGCOLOR=pink background = kars_yellow.gif>
<H1>Switch Information 
</h1>
EOF
}
sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}















##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}
#||||||||||||||||||||||||||||||not used|||||||||||||||||||||||||||||||||||||||||
#************************************************************************
sub afterTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { if ($hour==12) {$hour=0;}}
     if ($HOUR24>=$hour){return 1;}
     return 0;
}
sub beforeTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { 
        if ($hour==12) {$hour=0;} elsif ($hour==0) {$hour=24;} 
     }
     if ($HOUR24<=$hour){return 1;}
     return 0;
}
