#! /usr/bin/perl
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################


$signature="<font size=-1><i>ICS</i></font>";
%month=(begin,"00",January,"01",February,"02",March,"03",April,"04",May,"05",June,"06",July,"07",August,"08",September,"09",October,"10",November,"11",December,"12",end,"13");
#
# fields ------------------------------------------------
#  call accounts
#
# $BILLNUM=0;$PINNUM=1;$CALLID=2;$CALLDATE=3;$FROMNUM=4;$TERMNUM=5;$BILLAMT=6;$CALLTIME=7;$BILLTIME=8;$BILLSECS=9;$FROMCITY=10;$FROMSTATE=11;$TERMCITY=12;$TERMSTAT=13;$PREVPAY=14;$CREDITS=15;$CHARGES=16;$yearheader=19;

$BILLNUM=0;
$PINNUM=1;
$CALLDATE=2;
$FROMNUM=5;
$TERMNUM=6;
$BILLAMT=7;
$CALLTIME=3;
$BILLTIME=4;
$INTERNATIONAL=8;
$INITIALMINUTERATE=9;
$ADDITIONALMINUTERATE=10;
$yearheader=19;

# personal account indexes
#$ACCOUNTBILLNUM=8;$ACCOUNTPINNUM=11;$CREDITPAYMENT=15;$CHECKPAYMENT=19;

$ACCOUNTBILLNUM=0;
$ACCOUNTPINNUM=1;
$CREDITPAYMENT=2;
$CHECKPAYMENT=3;


$total=0;  
#$filename = "../../database/calls.db";
#$accountFile="../../database/onlineaccounts.txt";
$filename = "../../database/callsN.db";
$accountFile="../../database/accounts.db";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
&PrintHeader;
&openHtml;
#&ReadEntry;
#&EXECUTE;
print "<b>Will be awailable soon please wait!<b><br>";

&closeHtml;
#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form

   $accNo = ($in{'accountNo'}) ? $in{'accountNo'} : undef;
   $pinNo = ($in{'pinNo'}) ? $in{'pinNo'} : undef;	
   $fromMonth  = ($in{'fromMonth'}) ? $in{'fromMonth'} : 'begin';
   $fromYear = ($in{'fromYear'}) ? $in{'fromYear'} : '1900';
   $toMonth = ($in{'toMonth'}) ? $in{'toMonth'} : 'end';
   $toYear = ($in{'toYear'}) ? $in{'toYear'} : '2100';
   $fromHour = ($in{'fromTime'}) ? $in{'fromTime'} : 0 ;
   $fromAMPM = ($in{'fromAMPM'}) ? $in{'fromAMPM'} : "AM";
   $toHour = ($in{'toTime'}) ? $in{'toTime'} : 13;
   $toAMPM = ($in{'toAMPM'}) ? $in{'toAMPM'} : "PM";
   $origin = ($in{'originNumber'}) ? $in{'originNumber'} : -1;
   $number = ($in{'calledNumber'}) ? $in{'calledNumber'} : -1;	
#   $international = ($in{'international'}) ? $in{'international'} : undef;
#   $interstate = ($in{'interstate'}) ? $in{'interstate'} : undef;

   $checkedFrom = ($in{'from'}) ? 1 : 0 ;
   $checkedTo =($in{'to'}) ? 1 : 0 ;  
   $checkedBetween=($in{'between'}) ? 1 : 0 ;  
   $checkedOrigin=($in{'checkOriginNumber'}) ? 1 : 0 ;
   $checkedNumber=($in{'checkCalledNumber'}) ? 1 : 0 ;
   $checkedInternational = ($in{'international'}) ? 1:0;
   $checkedInterstate = ($in{'interstate'}) ? 1 : 0;

   $fromDate=$fromYear.$month{$fromMonth} ."00";
   $toDate=$toYear.$month{$toMonth} ."32";
   $fromTime=&convertTime2Number($fromHour,$fromAMPM);
   $toTime=&convertTime2Number($toHour,$toAMPM);

   return 0;
}

sub convertTime2Number {
     local ($hour,$ampm)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {;}
        else {$hour+=12};
     } else { if ($hour==12) {$hour=0;}}
     $n=$hour."0000";
     return $n;
}
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

#############################################################################
#  
#
#############################################################################
sub printVariables {

   print "\n
_______________________
   $accNo 
   $pinNo 
   $fromMonth 
   $fromYear
   $toMonth 
   $toYear 
   $fromtime 
   $fromAMPM 
   $totime 
   $toAMPM 
   $origin 
   $number 
   $international 
   $interstate 
+++++++++++++++++++++++
   ";
   print" fields\n";
   $j=0;
   foreach $i (@fields) {
        print "$i $j \n";$j++;
   }
   print "$HOUR , $AMPM , $CALLMONTH , $CALLDAY , $CALLYEAR, $CALLYEAR\n";
   
}
#############################################################################
#  verifiedAccount
#
#############################################################################
sub verifiedAccount {

        open(ACC, $accountFile);
        while (<ACC>) {
           (@fields)=split ( /\|/,$_);
                                                      #           $fields[$ACCOUNTBILLNUM]=~ s/[\-\)\(\s]//g;
            if ( ($fields[$ACCOUNTBILLNUM] eq $accNo) &&($fields[$ACCOUNTPINNUM] eq $pinNo)) {
               print "Account verified, please wait! <br>\n";
                $fields[$CREDITPAYMENT]=~ s/[\s\$]//g;
		$fields[$CHECKPAYMENT]=~ s/[\s\$]//g;
		$credits=$fields[$CREDITPAYMENT]+$fields[$CHECKPAYMENT];
               close(ACC);
               return 1;
            }
        }
        close(ACC);
        return 0;

}
sub invalidAccountException {
print "<b>Invalid account and pin number combination. Please try again.</b>\n";
}
### ##########################################################################
#  
# invalidAccountException
#############################################################################

sub openFile{
       open(IN,$filename);

}

sub EXECUTE {
        unless (&verifiedAccount) { &invalidAccountException; return 0;}
        
	#decide file name to open
        # open(IN, $filename);
        &openFile();
        $foundAcc=0;
        $continue=0;
        &openTable;
        print "<tr><td bgcolor=beige> <font color=blue><b>
CALL DATE</td><td bgcolor=beige><font color=blue><b>
FROM NUM</td><td bgcolor=beige><font color=blue><b>
TERM NUM</td><td bgcolor=beige><font color=blue><b>
BILL AMT</td><td bgcolor=beige><font color=blue><b>
CALL TIME</td><td bgcolor=beige><font color=blue><b>
BILL TIME</td><td bgcolor=beige><font color=blue><b>

INITIAL MINUTE RATE</td><td bgcolor=beige><font color=blue><b>
ADDITIONAL MINUTE RATE</td>
</tr>";
        $charges=0;
        while (<IN>) {
           (@fields)=split ( /\|/,$_);
           if ( ($fields[$BILLNUM] eq $accNo) ) { 
               $charges+=$fields[$BILLAMT];
               &processCall(@fields);
             #  $continue=$foundAcc=1;
           } #else { $continue=0; }
#           if ($foundAcc && $continue) {} else {break;}
        }
        &closeTable;
        close(IN);
        $total=~ s/(\d*)\.(\d)(\d)(\d*)/$1.$2$3/;

        print "<table bgcolor=yellow><tr><td><b> $total is total for these calls.</b></td></tr></table>";
#          print "<table bgcolor=pink><tr><td><b> Previous Payment is  </td> </tr>";
        $balance=$credits-$charges ;
        $balance=sprintf("%10.2f",$balance); #$balance=~ s/(\d*)\.(\d)(\d)(\d*)/$1.$2$3/;

        if ($balance >=0) { $balance="".$balance."CR"; }
        print "<table bgcolor=cyan><tr><td><b> Current Balance  is $balance  </b></td></tr>\n </table>";
}


#
##############################################################################
#
# process a call item 
#
##############################################################################
sub processCall {
 local (@fields)=@_;

# &printVariables;
 if (   ( ($checkedFrom 
		&& (    $fromDate <= $fields[$CALLDATE] ) 
	  ) || !$checkedFrom
	)
       	&&( 
	  ($checkedTo 
	       && ($toDate >=  $fields[$CALLDATE] )
	  ) || !$checkedTo
	)
	&&( 
          ($checkedBetween
	      && ( $fields[$CALLTIME] >= $fromTime)
	      && ( $fields[$CALLTIME] <= $toTime)
          ) || !$checkedBetween
        )
        && (
	  ($checkedOrigin
		&& (($origin==$fields[$FROMNUM]))
	  ) || !$checkedOrigin
	)
        && (
          ($checkedNumber
	      && (($number==$fields[$TERMNUM]))
          ) || !$checkedNumber
        )
	&& (	
	    (($fields[$INTERNATIONAL]==1) && $checkedInternational )
	    ||
	    (($fields[$INTERNATIONAL]==0) && $checkedInterstate )
	   )
      #-------
      )
 {
     &printCall;
     $total+=$fields[$BILLAMT];
     
 } # if ends
    

}

#
##############################################################################
#
# Results
#
##############################################################################
sub printCall {
$fields[$CALLDATE]=substr($fields[$CALLDATE],4,2)."/".substr($fields[$CALLDATE],6,2)."/". substr($fields[$CALLDATE],0,4);
$fields[$CALLTIME]=substr($fields[$CALLTIME],0,2).":".substr($fields[$CALLTIME],2,2).":".substr($fields[$CALLTIME],4,2);
$fields[$BILLTIME]=substr($fields[$BILLTIME],0,2).":".substr($fields[$BILLTIME],2,2).":".substr($fields[$BILLTIME],4,2);

    print "<tr>
<td>
$fields[$CALLDATE]</td><td>
$fields[$FROMNUM]</td><td>
$fields[$TERMNUM]</td><td>
$fields[$BILLAMT]</td><td>
$fields[$CALLTIME]</td><td>
$fields[$BILLTIME]</td><td>

$fields[$INITIALMINUTERATE]</td><td>
$fields[$ADDITIONALMINUTERATE]</td><td>
</tr>";
}


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}
sub printFooter {
  print "$signature </body></html>\n";
}

sub openTable {
print "
<TABLE ALIGN=ABSCENTER BORDER=5 CELLSPACING=6 CELLPADDING=6 BGCOLOR=gold >
";
}
sub closeTable {
print "</table>";
}
sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title>Query Results </title>
</HEAD>
<body BGCOLOR=pink background = query.gif>
<H1>Account Information for account $accNo with pin number is $pinNo </h1>

EOF
}
sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}















##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}
#||||||||||||||||||||||||||||||not used|||||||||||||||||||||||||||||||||||||||||
#************************************************************************
sub afterTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { if ($hour==12) {$hour=0;}}
     if ($HOUR24>=$hour){return 1;}
     return 0;
}
sub beforeTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { 
        if ($hour==12) {$hour=0;} elsif ($hour==0) {$hour=24;} 
     }
     if ($HOUR24<=$hour){return 1;}
     return 0;
}
