#! /usr/bin/perl
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################


$signature="<font size=-1><i>ICS</i></font>";
%month=(begin,0,January,1,February,2,March,3,April,4,May,5,June,6,July,7,August,8,September,9,October,10,November,11,December,12,end,13);
#
# fields ------------------------------------------------
# call accounts
#
$BILLNUM=0;
$PINNUM=1;
$CALLID=2;
$CALLDATE=3;
$FROMNUM=4;
$TERMNUM=5;
$BILLAMT=6;
$CALLTIME=7;
$BILLTIME=8;
$BILLSECS=9;
$FROMCITY=10;
$FROMSTATE=11;
$TERMCITY=12;
$TERMSTAT=13;
$PREVPAY=14;
$CREDITS=15;
$CHARGES=16;
$yearheader=19;
# personal account indexes
$ACCOUNTBILLNUM=8;
$ACCOUNTPINNUM=11;
$CREDITPAYMENT=15;
$CHECKPAYMENT=19;


$total=0;  
$filename = "../../calls.db";
$accountFile="onlineaccounts.txt";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
$ora_debug = shift if $ARGV[0] =~ /^-#/;
&PrintHeader;
&openHtml;
&ReadEntry;
&EXECUTE;
&closeHtml;
#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form

   $accNo = ($in{'accountNo'}) ? $in{'accountNo'} : undef;
   $pinNo = ($in{'pinNo'}) ? $in{'pinNo'} : undef;	
   $fromMonth  = ($in{'fromMonth'}) ? $in{'fromMonth'} : 'begin';
   $fromYear = ($in{'fromYear'}) ? $in{'fromYear'} : '1900';
   $toMonth = ($in{'toMonth'}) ? $in{'toMonth'} : 'end';
   $toYear = ($in{'toYear'}) ? $in{'toYear'} : '2100';
   $fromtime = ($in{'fromTime'}) ? $in{'fromTime'} : 0 ;
   $fromAMPM = ($in{'fromAMPM'}) ? $in{'fromAMPM'} : "AM";
   $totime = ($in{'toTime'}) ? $in{'toTime'} : 13;
   $toAMPM = ($in{'toAMPM'}) ? $in{'toAMPM'} : "PM";
   $origin = ($in{'origin'}) ? $in{'origin'} : -1;
   $number = ($in{'number'}) ? $in{'number'} : -1;	
   $international = ($in{'international'}) ? $in{'international'} : undef;
   $interstate = ($in{'interstate'}) ? $in{'interstate'} : undef;
   $checkedFrom = ($in{'from'}) ? 1 : 0 ;
   $checkedTo =($in{'to'}) ? 1 : 0 ;  
   $checkedBetween=($in{'between'}) ? 1 : 0 ;  
   $checkedOrigin=($in{'origin'}) ? 1 : 0 ;
   $checkedNumber=($in{'number'}) ? 1 : 0 ;


$accNo=3154250788;
$pinNo=8078;
   return 0;
}


#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

#############################################################################
#  
#
#############################################################################
sub printVariables {

   print "\n
_______________________
   $accNo 
   $pinNo 
   $fromMonth 
   $fromYear
   $toMonth 
   $toYear 
   $fromtime 
   $fromAMPM 
   $totime 
   $toAMPM 
   $origin 
   $number 
   $international 
   $interstate 
+++++++++++++++++++++++
   ";
   print" fields\n";
   $j=0;
   foreach $i (@fields) {
        print "$i $j \n";$j++;
   }
   print "$HOUR , $AMPM , $CALLMONTH , $CALLDAY , $CALLYEAR, $CALLYEAR\n";
   
}
#############################################################################
#  verifiedAccount
#
#############################################################################
sub verifiedAccount {

        open(IN, $accountFile);
        while (<IN>) {
           (@fields)=split ( /\|/,$_);
           $fields[$ACCOUNTBILLNUM]=~ s/[\-\)\(\s]//g;
            if ( ($fields[$ACCOUNTBILLNUM] eq $accNo) &&($fields[$ACCOUNTPINNUM] eq $pinNo)) {
               print "Account verified <br>\n";
		$fields[$CREDITPAYMENT]=~ s/[\s\$]//g;
		$fields[$CHECKPAYMENT]=~ s/[\s\$]//g;
		$credits=$fields[$CREDITPAYMENT]+$fields[$CHECKPAYMENT];
               close(IN);
               return 1;
            }
        }
        close(IN);
        return 0;

}
sub invalidAccountException {
print "<b>Invalid account and pin number combination. Please try again.</b>\n";
}
#############################################################################
#  
# invalidAccountException
#############################################################################

sub openFile{
       open(IN,$filename);

}

sub EXECUTE {
        unless (&verifiedAccount) { &invalidAccountException; return 0;}
        
	#decide file name to open
        # open(IN, $filename);
        &openFile();
        $foundAcc=0;
        $continue=0;
        &openTable;
        print "<tr><td>
CALL ID</td><td>
CALL DATE</td><td>
FROM NUM</td><td>
TERM NUM</td><td>
BILL AMT</td><td>
CALL TIME</td><td>
BILL TIME</td><td>
BILL SECS</td><td>
FROM CITY</td><td>
FROM STATE</td><td>
TERMINAL CITY</td><td>
TERMINAL STATE</td><td>
</tr>";
        $charges=0;
        while (<IN>) {
           (@fields)=split ( /\|/,$_);
           if ( ($fields[$BILLNUM] eq $accNo) ) { 
               $charges+=$fields[$BILLAMT];
               &processCall(@fields);
               $continue=$foundAcc=1;
           } else { $continue=0; }
#           if ($foundAcc && $continue) {} else {break;}
        }
        &closeTable;
        close(IN);
        $total=~ s/(\d*)\.(\d)(\d)(\d*)/$1.$2$3/;

        print "<table bgcolor=yellow><tr><td><b> $total is total for these calls.</b></td></tr></table>";
        print "<table bgcolor=pink><tr><td><b> Previous Payment is  </td> </tr>";
        $balance=$credits-$charges ;
        $balance=~ s/(\d*)\.(\d)(\d)(\d*)/$1.$2$3/;

        if ($balance >=0) { $balance="".$balance."CR"; }
        print "<tr><td><b> Current Balance  is $balance  </b></td></tr>\n </table>";
}
#************************************************************************
sub afterTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { if ($hour==12) {$hour=0;}}
     if ($HOUR24>=$hour){return 1;}
     return 0;
}
sub beforeTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { 
        if ($hour==12) {$hour=0;} elsif ($hour==0) {$hour=24;} 
     }
     if ($HOUR24<=$hour){return 1;}
     return 0;
}


#
##############################################################################
#
# process a call item 
#
##############################################################################
sub processCall {
 local (@fields)=@_;
 $fields[$CALLDATE]=~ s/\ 0\:00\:00//g;

 ($CALLMONTH,$CALLDAY,$CALLYEAR)= split ( /\//,$fields[$CALLDATE]);
 $CALLYEAR=$yearheader.$CALLYEAR; 
 $CALLYEAR=1997;
 ($HOUR,$AMPM)=split ( /\:/,$fields[$CALLTIME]);
  if( $AMPM =~ /PM/) {      #convert to 24 hours
      if ($HOUR==12) {$HOUR=0;}
      $HOUR24= $HOUR+12;
  }
 $fields[$TERMNUM]=~ s/[\-\)\(\s]//g;
# &printVariables;
 if (   ( ($checkedFrom 
		&& ($month{$fromMonth} <= $CALLMONTH) 
		&& ($fromYear <= $CALLYEAR)
	  ) || !$checkedFrom
	)
       	&&( 
	  ($checkedTo 
	       && ($month{$toMonth} >= $CALLMONTH)
	       && ($toYear >= $CALLYEAR)
	  ) || !$checkedTo
	)
	&&( 
          ($checkedBetween
	      && ( &afterTime($fromtime,$fromAMPM,$HOUR24))
	      && ( &beforeTime($totime,$toAMPM,$HOUR24))
          ) || !$checkedBetween
        )

#      && (($origin==$fields[$FROMNUM])||$origin==-1)
#      && (($number==$fields[$TERMNUM])||$number==-1)
      )
 {
     &printCall;
     $total+=$fields[$BILLAMT];
     
 } # if ends
    

}

#
##############################################################################
#
# Results
#
##############################################################################
sub printCall {
    print "<tr>
<td>
$fields[$CALLID]</td><td>
$fields[$CALLDATE]</td><td>
$fields[$FROMNUM]</td><td>
$fields[$TERMNUM]</td><td>
$fields[$BILLAMT]</td><td>
$fields[$CALLTIME]</td><td>
$fields[$BILLTIME]</td><td>
$fields[$BILLSECS]</td><td>
$fields[$FROMCITY]</td><td>
$fields[$FROMSTATE]</td><td>
$fields[$TERMCITY]</td><td>
$fields[$TERMSTAT]</td><td>
</tr>";
}




# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}
sub printFooter {
  print "$signature </body></html>\n";
}

sub openTable {
print "
<TABLE ALIGN=ABSCENTER BORDER=5 CELLSPACING=6 CELLPADDING=6 BGCOLOR=bisque >
";
}
sub closeTable {
print "</table>";
}
sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title>Query Results </title>
</HEAD>
<body BGCOLOR=white background = query.gif>
<H1>Query Results </h1>
<BR>
EOF
}
sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}















##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}

