#!/usr/bin/perl
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################


$filename = "../main.html";
$outfile =  "tmpMainHtml";
$newsfile = "../news.html";
$accountFile="../../database/announcement.db";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
&PrintHeader;
&ReadEntry;

&EXECUTE;
#print "<b>Will be awailable soon please wait!<b><br>";


#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form

   $announcement = ($in{'announcement'}) ? $in{'announcement'} : "Follow these space";
   $color = ($in{'color'}) ? $in{'color'} : "green";
   $bgcolor = ($in{'bgcolor'}) ? $in{'bgcolor'} : "black";
   $style = ($in{'style'}) ? $in{'style'} : "Bold";
   $speed = ($in{'speed'}) ? $in{'speed'} : 30;
   $size = ($in{'size'}) ? $in{'size'} : 24;
   $dist = ($in{'dist'}) ? $in{'dist'} : 3;
   $alignment = ($in{'alignment'}) ? $in{'alignment'} : Center;
   $link = ($in{'link'}) ? $in{'link'} : "Please see the announcements";
   $font = ($in{'font'}) ? $in{'font'} : "Helvetica";
   $name = ($in{'name'}) ? $in{'name'} : -1;
   $userid = ($in{'userid'}) ? $in{'userid'} : -1;
   $password = ($in{'password'}) ? $in{'password'} : -1;	
   return 0;
}


#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

#############################################################################
#  
#
#############################################################################

#############################################################################
#  verifiedAccount
#
#############################################################################
sub verifiedAccount {

        open(ACC, $accountFile);
        while (<ACC>) {
           ($ID,$PW,@rest)=split ( /\|/,$_);
            if ( ($userid eq $ID) &&($PW eq $password)) {
               close(ACC);
               return 1;
            }
        }
        close(ACC);
        return 0;

}
sub invalidAccountException {
&openHtml; 
print "<br>.<br>.<br>.<br><b>Sorry, access denied!<br>
.</b> <br>.<br>.<br>.<br>\n";
&closeHtml;
}
### ##########################################################################
#  
# invalidAccountException
#############################################################################

sub openFile{
       open(IN,$filename);

}

sub EXECUTE {
        unless (&verifiedAccount) { &invalidAccountException; return 0;}
        

	&produceMainHtml;
	&produceNewsHtml;
&openHtml; 
print "<br>.<br>.<br>.<br><b>
Success<br>
Please check the results.<br>
<a href=http://2ics.com/main.html>Main Page.</a><br>
<a href=http://2ics.com/news.html>News Page.</a><br>
.</b> <br>.<br>.<br>.<br>\n";
&printFooter;
&closeHtml;
}	
	
#

#
##############################################################################
#
# Results
#
##############################################################################



# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}


sub produceMainHtml {
       open(IN,$filename) ||print "cannot open $filename $fn\n";
       open(OUT,">$outfile") ||print "cannot open $outfile $fn\n";
       while (!($line =~ /^\<!-- \@\@/ )) {
	   $line=<IN> ;
	   print  OUT $line;
	   }
       print OUT <<EOF;
<!-- @@ FOLLOWINGS ARE NEW ANNOUNCEMENTS -->
<CENTER>
       <APPLET  archive=applets.jar
       CODE="TextScrollerApplet.class" WIDTH=500 HEIGHT=40>
        <!-- PARAM NAME=remoteText VALUE="scroll.txt"-->
      
       <PARAM NAME=text VALUE=" $announcement " >
       <PARAM NAME=speed VALUE="$speed">
       <PARAM NAME=dist VALUE="$dist">
       <PARAM NAME=font VALUE="$font">
       <PARAM NAME=size VALUE="$size">
       <PARAM NAME=style VALUE="$style">
       <PARAM NAME=alignment VALUE="$alignment">
       <PARAM NAME=textColor VALUE="$color">
       <PARAM NAME=backgroundColor VALUE="$bgcolor">
       <STRONG>Your browser does not understand the HTML tag "Applet"</STRONG>
       </APPLET><br>
	<font face="Helvetica" color=yellow>  <a href=news.html> $link </a> </font>
</center>
<!-- \$\$ END OF NEW  ANNOUNCEMENTS -->
EOF
       while (!($line =~ /^\<!-- \$\$/ )) {
	   $line=<IN> ;
	   }
       while (<IN>) {
	   print OUT $_;
	   }
       close(IN);
       close(OUT);
       open(OUT,">$filename") ||print "cannot open $filename $fn\n";
       open(IN,$outfile) ||print "cannot open $outfile $fn\n";
       while (<IN>) {
	   print OUT $_;
	   }
       close(IN);
       close(OUT);

#       rename($outfile,$filename); unlink($outfile);
#       system("cp $outfile $filename");
}



sub produceNewsHtml {
    $now=`date`;
    chop($now);
       open(IN,$newsfile) ||print "cannot open $newsfile $fn\n";
       open(OUT,">$outfile") ||print "cannot open $outfile $fn\n";
       while (!($line =~ /^\<!-- \@\@/ )) {
	   $line=<IN> ;
	   print  OUT $line;
	   }
       print OUT <<EOF;
<!-- @@ FOLLOWINGS ARE NEW ANNOUNCEMENTS -->
<!-- \$\$ END OF NEW  ANNOUNCEMENTS -->
<!-- \#\# $now -->
<LI><B><font color=blue> $now </font><br>
<ul> $announcement</ul> </B></LI>
<!-- \*\* $now -->
EOF
       while (!($line =~ /^\<!-- \$\$/ )) {
	   $line=<IN> ;
	   }
       while (<IN>) {
	   print OUT $_;
	   }
       close(IN);
       close(OUT);
       open(OUT,">$newsfile") ||print "cannot open $newsfile $fn\n";
       open(IN,$outfile) ||print "cannot open $outfile $fn\n";
       while (<IN>) {
	   print OUT $_;
	   }
       close(IN);
       close(OUT);
   }












##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}

#
##############################################################################


sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title>Query Results </title>
</HEAD>
<body BGCOLOR=pink background = query.gif>

EOF
}
sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}

sub printFooter {
  print "$signature </body></html>\n";
}



