#!/usr/bin/perl
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################


$newsfile = "../news.html";
$outfile ="tmpNewsHtml";
$accountFile="../../database/announcement.db";
 $deleted=0;
#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
&PrintHeader;
&ReadEntry;

&EXECUTE;
#print "<b>Will be awailable soon please wait!<b><br>";


#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form

   $userid = ($in{'userid'}) ? $in{'userid'} : -1;
   $password = ($in{'password'}) ? $in{'password'} : -1;	
   $date = ($in{'date'}) ? $in{'date'} : -129384232;
   return 0;
}


#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

#############################################################################
#  
#
#############################################################################

#############################################################################
#  verifiedAccount
#
#############################################################################
sub verifiedAccount {

        open(ACC, $accountFile);
        while (<ACC>) {
           ($ID,$PW,@rest)=split ( /\|/,$_);
            if ( ($userid eq $ID) &&($PW eq $password)) {
               close(ACC);
               return 1;
            }
        }
        close(ACC);
        return 0;

}
sub invalidAccountException {
&openHtml; 
print "<br>.<br>.<br>.<br><b>Sorry, access denied!
.</b> <br>.<br>.<br>.<br>\n";
&closeHtml;
}
### ##########################################################################
#  
# invalidAccountException
#############################################################################

sub openFile{
       open(IN,$filename);

   }

sub EXECUTE {
        unless (&verifiedAccount) { &invalidAccountException; return 0;}
        
	&deleteNews;
	if ($deleted) {
	    &returnSuccess;
	} else { &returnFailed;}
    }


#

#
##############################################################################
#
# Results
#
##############################################################################

sub returnSuccess {
&openHtml; 
print "<br>.<br>.<br>.<br><b>Success:<br>
See the latest <a href=http://www.2ics.com/news.html>news</a><br>
.</b> <br>.<br>.<br>.<br>\n";
&closeHtml;
}
sub returnFailed {
&openHtml; 
print "<br>.<br>.<br>.<br><b>Sorry, could not find the news!
.</b> <br>.<br>.<br>.<br>\n";
&closeHtml;
}


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}





sub deleteNews {
    $now=`date`;
    chop($now)
;
       open(IN,$newsfile) ||print "cannot open $newsfile $fn\n";
       open(OUT,">$outfile") ||print "cannot open $outfile $fn\n";
       while (!($line =~ /^\<!-- \#\#/ )) {
	   print  OUT $line;
	   $line=<IN> ;
	   }
       

    $buffer= $line;
       while (<IN>) {
	   $line=$_ ;
	   $buffer.= $line;
	   if ($line =~ /^\<!-- \*\*/ ) {
	       if ( $buffer =~ /$date/ ) {
		   $buffer="";
		   $deleted=1;
	       }
	       print OUT $buffer;
	       $buffer="";
	   }
       }
    print OUT $buffer;
    close(IN);
    close(OUT);
    open(OUT,">$newsfile") ||print "cannot open $newsfile $fn\n";
    open(IN,$outfile) ||print "cannot open $outfile $fn\n";
    while (<IN>) {
	print OUT $_;
    }
    close(IN);
    close(OUT);
}










##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}

#
##############################################################################


sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title>Query Results </title>
</HEAD>
<body BGCOLOR=pink background = query.gif>

EOF
}
sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}

sub printFooter {
  print "$signature </body></html>\n";
}


