#! /usr/bin/perl
#############################################################################
# 
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################


$signature="<font size=-1><i>ICS</i></font>";
%month=(begin,"00",January,"01",February,"02",March,"03",April,"04",May,"05",June,"06",July,"07",August,"08",September,"09",October,"10",November,"11",December,"12",end,"13");
#
# fields ------------------------------------------------
#  call accounts
#


$ACCPINNUM=0;
$CALLDATE=1;
$CALLTIME=2;
$FROMNUM=3;
$TERMNUM=4;
$BILLTIME=5;
$BILLAMT=6;

$INTERNATIONAL=7;
#   $INITIALMINUTERATE=9;
#    $ADDITIONALMINUTERATE=10;
$yearheader=19;

# personal account indexes
#$ACCOUNTBILLNUM=8;$ACCOUNTPINNUM=11;$CREDITPAYMENT=15;$CHECKPAYMENT=19;

$ACCOUNTBILLNUM=0;
$ACCOUNTPINNUM=1;
           #$CREDITPAYMENT=2;
           #$CHECKPAYMENT=3;
$PAYDATE=2;
$PAYMENT=3;


$total=0;  
$dirname = "../../database/pcc/";
$accountFile="accounts.db";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
&PrintHeader;
&ReadEntry;
&openHtml; 
&EXECUTE;
#print "<font color=red>.<br>.<br>.<br>.<br>.<br><b> Will be available soon, please wait!<b>.<br>.<br>.<br><br></font>";

&closeHtml;
#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form

   $accNo = ($in{'accountNo'}) ? $in{'accountNo'} : -1;
   $pinNo = ($in{'pinNo'}) ? $in{'pinNo'} : -1;	
   $fromDay  = ($in{'fromDay'}) ? $in{'fromDay'} : 'begin';
   $fromMonth  = ($in{'fromMonth'}) ? $in{'fromMonth'} : 'begin';
   $fromYear = ($in{'fromYear'}) ? $in{'fromYear'} : '1900';
   $toMonth = ($in{'toMonth'}) ? $in{'toMonth'} : 'end';
   $toDay = ($in{'toDay'}) ? $in{'toDay'} : 'end';
   $toYear = ($in{'toYear'}) ? $in{'toYear'} : '2100';
   $fromHour = ($in{'fromTime'}) ? $in{'fromTime'} : 0 ;
   $fromAMPM = ($in{'fromAMPM'}) ? $in{'fromAMPM'} : "AM";
   $toHour = ($in{'toTime'}) ? $in{'toTime'} : 13;
   $toAMPM = ($in{'toAMPM'}) ? $in{'toAMPM'} : "PM";
   $origin = ($in{'originNumber'}) ? $in{'originNumber'} : -1;
   $number = ($in{'calledNumber'}) ? $in{'calledNumber'} : -1;	
#   $international = ($in{'international'}) ? $in{'international'} : undef;
#   $interstate = ($in{'interstate'}) ? $in{'interstate'} : undef;

   $checkedFrom = ($in{'from'}) ? 1 : 0 ;
   $checkedTo =($in{'to'}) ? 1 : 0 ;  
   $checkedBetween=($in{'between'}) ? 1 : 0 ;  
   $checkedOrigin=($in{'checkOriginNumber'}) ? 1 : 0 ;
   $checkedNumber=($in{'checkCalledNumber'}) ? 1 : 0 ;
   $checkedInternational = ($in{'international'}) ? 1:0;
   $checkedInterstate = ($in{'interstate'}) ? 1 : 0;

#   $fromDate=$fromYear.$month{$fromMonth} ."00";
#   $toDate=$toYear.$month{$toMonth} ."32";
   $fromDate=$fromYear.$month{$fromMonth} .$fromDay;
   $toDate=$toYear.$month{$toMonth} .$toDay;
   $fromTime=&convertTime2Number($fromHour,$fromAMPM);
   $toTime=&convertTime2Number($toHour,$toAMPM);

   $accpinNo=$accNo.$pinNo;
   return 0;
}

sub convertTime2Number {
     local ($hour,$ampm)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {;}
        else {$hour+=12};
     } else { if ($hour==12) {$hour=0;}}
     $n=$hour."0000";
     return $n;
}
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

#############################################################################
#  
#
#############################################################################
sub printVariables {

   print "\n
_______________________
   $accNo 
   $pinNo 
   $fromMonth 
   $fromYear
   $toMonth 
   $toYear 
   $fromtime 
   $fromAMPM 
   $totime 
   $toAMPM 
   $origin 
   $number 
   $international 
   $interstate 
+++++++++++++++++++++++
   ";
   print" fields\n";
   $j=0;
   foreach $i (@fields) {
        print "$i $j \n";$j++;
   }
   print "$HOUR , $AMPM , $CALLMONTH , $CALLDAY , $CALLYEAR, $CALLYEAR\n";
   
}
#############################################################################
#  verifiedAccount
#
#############################################################################
sub verifiedAccount {
    $found=0;
    $credits=0;
    open(IN, $dirname.$accountFile);
    print "<font color=blue><h2>PAYMENTS</h2></font><font color=green>";
        while (<IN>) {
           (@fields)=split ( /\,/,$_);
                         #           $fields[$ACCOUNTBILLNUM]=~ s/[\-\)\(\s]//g;
            if ( ($fields[$ACCOUNTBILLNUM] eq $accNo) &&($fields[$ACCOUNTPINNUM] eq $pinNo)) {
	       print "<h4>Payment of $fields[$PAYMENT] on $fields[$PAYDATE]</h4>";
	       $fields[$PAYMENT]=~ s/[\s\$]//g;
###########                $fields[$CREDITPAYMENT]=~ s/[\s\$]//g;
###########		$fields[$CHECKPAYMENT]=~ s/[\s\$]//g;
###########		$credits=$fields[$CREDITPAYMENT]+$fields[$CHECKPAYMENT];
	       $credits+=$fields[$PAYMENT];
	       $found=1;
               #########################################################close(IN);
               #########################################################return 1;
            }
        }
    print "</font>"; 
        close(IN);
        return $found;
}
sub invalidAccountException {
print "<br>.<br>.<br>.<br><b>Invalid $accNo account and $pinNo pin number combination. Please
try again.</b><br>.<br>.<br>.<br>\n";
}
### ##########################################################################
#  
# invalidAccountException
#############################################################################
sub EXECUTE {
#--        unless (&verifiedAccount) { &invalidAccountException; return 0;}
  &verifiedAccount;      
        &openTable;
        print "<tr><td bgcolor=beige> <font color=blue><b>
CALL DATE</td><td bgcolor=beige><font color=blue><b>
CALL TIME</td><td bgcolor=beige><font color=blue><b>   
FROM NUM</td><td bgcolor=beige><font color=blue><b>
CALLED NUM</td><td bgcolor=beige><font color=blue><b>
COST</td><td bgcolor=beige><font color=blue><b>
DURATION</td><td bgcolor=beige width=40><font color=blue><b>
INTER- <font size=-1 >NATIONAL</td>
</tr>";
        $charges=0;
	opendir(CALLS, $dirname) || die "no dir .";
	foreach $fn (sort readdir(CALLS)) {
	    if ($fn =~ /^pcc_calls/) {&scanFile($dirname,$fn);}
 #		print "<tr><td> $fn </td></tr>";
	}
	closedir(CALLS);

        &closeTable;
        $total=~ s/(\d*)\.(\d)(\d)(\d*)/$1.$2$3/;

        print "<table bgcolor=yellow><tr><td><b> $total is total for these calls.</b></td></tr></table>";
#          print "<table bgcolor=pink><tr><td><b> Previous Payment is  </td> </tr>";
        $balance=$credits-$charges ;
        $balance=sprintf("%10.2f",$balance); #$balance=~ s/(\d*)\.(\d)(\d)(\d*)/$1.$2$3/;

        if ($balance >=0) { $balance="".$balance."CR"; }
        print "<table bgcolor=cyan><tr><td><b> Current Balance  is $balance  </b></td></tr>\n </table>";
    }
#
##############################################################################
#  scanFile: process each file in the directory
#
##############################################################################
sub scanFile {
    local($dirname,$fn)=@_;

    ($h1,$h2,$date,$e)=split ( /_/,$fn);
    ($y,$m,$d1,$d2)=split ( /-/,$date);
    if ($y =~ /^9/ ) {$y="19".$y;}else{$y="20".$y;}
    if ($d2 eq "") {$d2=$d1;}
    if ($d2 <$d1) {$td=$d1; $d1=$d2;$d2=$td;}
    if ( $checkedFrom  &&
	($fromYear > $y || $month{$fromMonth} >$m || ( $d2 ne "" &&  $fromDay > $d2))) {
	return 0;
    }
    if ( $checkedTo  &&
	($y > $toYear||$m > $month{$toMonth} ||( $d1 ne "" &&$d1 > $toDay))) {
	return 0;
    }
    print "<font color=red><b>.</b></font>";
    $realfile=$dirname.$fn;
    open(IN, "<$realfile"); 
    while (<IN>) {
	(@fields)=split ( /\|/,$_);
	if ( ($fields[$ACCPINNUM] eq $accpinNo) && ($fields[$BILLAMT] != 0)) { 
	    
	    $fields[$BILLAMT]/=100;
	    $charges+=$fields[$BILLAMT];
	    &processCall(@fields);
	} 
    }
    close(IN);
}


#
##############################################################################
#
# process a call item 
#
##############################################################################
sub processCall {
    local (@fields)=@_;

# &printVariables;
    if (   ( ($checkedFrom 
	      && (    $fromDate <= $fields[$CALLDATE] ) 
	      ) || !$checkedFrom
	    )
       	&&( 
	   ($checkedTo 
	    && ($toDate >=  $fields[$CALLDATE] )
	    ) || !$checkedTo
	   )
	&&( 
	   ($checkedBetween
            && (
                    ($fromTime <$toTime
                     && ( $fields[$CALLTIME] >= $fromTime)
                     && ( $fields[$CALLTIME] <= $toTime)
                     )
                     ||
                    ($fromTime >=$toTime
                     && (( $fields[$CALLTIME] >= $fromTime)
                        || ( $fields[$CALLTIME] <= $toTime))
                     )
                )
            ) || !$checkedBetween
           )
        && (
	    ($checkedOrigin
	     && (($fields[$FROMNUM]=~ /^$origin/ )) 
	     ) || !$checkedOrigin
	    )
        && (
	    ($checkedNumber
	     && (($fields[$TERMNUM]=~ /^$number/ )) 
	     ) || !$checkedNumber
	    )
	&& (	
	    (($fields[$INTERNATIONAL] eq "Y") && $checkedInternational )
	    ||
	    (($fields[$INTERNATIONAL] eq "N") && $checkedInterstate )
	    )
	#-------
	)
    {
	&printCall;
	$total+=$fields[$BILLAMT];
	
    } # if ends
    

}

#
##############################################################################
#
# Results
#
##############################################################################
sub printCall {
$fields[$CALLDATE]=substr($fields[$CALLDATE],4,2)."/".substr($fields[$CALLDATE],6,2)."/". substr($fields[$CALLDATE],0,4);
# $fields[$BILLTIME].=" sec";  #substr($fields[$BILLTIME],0,2).":".substr($fields[$BILLTIME],2,2);
$_sec=$fields[$BILLTIME]%60;
$_min=($fields[$BILLTIME]-$_sec)/60;
if ($_sec > 0 ) {  $_min++; }
$fields[$BILLTIME]=$_min." <font size=-2 color=red>min</font>";                         #":".$_sec;
$fields[$CALLTIME]=substr($fields[$CALLTIME],0,2).":".substr($fields[$CALLTIME],2,2);
$tn=$fields[$TERMNUM];
if ($tn =~ /^1/) { 
    $tn="<b><font color=green>1</font><font color=red>".substr($tn,1,length($tn)-8)."</font>".substr($tn,length($tn)-7,7)."</b>";
} elsif ($tn =~ /^011/)  {
    $tn="<b><font color=green>011</font><font color=red>".substr($tn,3,length($tn)-10)."</font>".substr($tn,length($tn)-7,7)."</b>";
}
$fields[$TERMNUM]=$tn;


    print "<tr>
<td>
$fields[$CALLDATE]</td><td>
$fields[$CALLTIME]</td><td>  
$fields[$FROMNUM]</td><td>
$fields[$TERMNUM]</td><td>
$fields[$BILLAMT]</td><td>
$fields[$BILLTIME]</td><td>
$fields[$INTERNATIONAL]</td>


</tr>";
}


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}
sub printFooter {
  print "$signature </body></html>\n";
}

sub openTable {
print "
<TABLE ALIGN=ABSCENTER BORDER=5 CELLSPACING=6 CELLPADDING=6 BGCOLOR=gold >
";
}
sub closeTable {
print "</table>";
}
sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title>Query Results </title>
</HEAD>
<body BGCOLOR=pink background = query.gif>
<H1>Account Information for account $accNo 
</h1>
EOF
}
sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}















##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}
#||||||||||||||||||||||||||||||not used|||||||||||||||||||||||||||||||||||||||||
#************************************************************************
sub afterTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { if ($hour==12) {$hour=0;}}
     if ($HOUR24>=$hour){return 1;}
     return 0;
}
sub beforeTime {
     local ($hour,$ampm,$HOUR24)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {$hour=0;}
        $hour+=12;
     } else { 
        if ($hour==12) {$hour=0;} elsif ($hour==0) {$hour=24;} 
     }
     if ($HOUR24<=$hour){return 1;}
     return 0;
}
